<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: SR_MovimientoDetalle.xml */
/* Generado: 2020-08-18 04:21:31 */

/* Mantenimiento de los registros de la tabla SR_MovimientoDetalle */
abstract class BaseSR_MovimientoDetalleDP extends SR_MovimientoDetalleBV
{
    /* Constructor ( Establece los valores desde un objeto SR_MovimientoDetalleBN ) */
    public function __construct( SR_MovimientoDetalleBN $o_SR_MovimientoDetalleBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_SR_MovimientoDetalleBN ) )
        {
            $this->setByBN( $o_SR_MovimientoDetalleBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto SR_MovimientoDetalleBN */
    public function setByBN( SR_MovimientoDetalleBN $o_SR_MovimientoDetalleBN )
    {
        if ( !is_null( $o_SR_MovimientoDetalleBN->getMovimientoDetalleId() ) )
        {
            $this->setMovimientoDetalleId( $o_SR_MovimientoDetalleBN->getMovimientoDetalleId() );
        }
        if ( !is_null( $o_SR_MovimientoDetalleBN->getMovimientoId() ) )
        {
            $this->setMovimientoId( $o_SR_MovimientoDetalleBN->getMovimientoId() );
        }
        if ( !is_null( $o_SR_MovimientoDetalleBN->getProductoId() ) )
        {
            $this->setProductoId( $o_SR_MovimientoDetalleBN->getProductoId() );
        }
        if ( !is_null( $o_SR_MovimientoDetalleBN->getIdLote() ) )
        {
            $this->setIdLote( $o_SR_MovimientoDetalleBN->getIdLote() );
        }
        if ( !is_null( $o_SR_MovimientoDetalleBN->getCantidad() ) )
        {
            $this->setCantidad( $o_SR_MovimientoDetalleBN->getCantidad() );
        }
        if ( !is_null( $o_SR_MovimientoDetalleBN->getCantidadEscaneada() ) )
        {
            $this->setCantidadEscaneada( $o_SR_MovimientoDetalleBN->getCantidadEscaneada() );
        }
        if ( !is_null( $o_SR_MovimientoDetalleBN->getInicioEscaneo() ) )
        {
            $this->setInicioEscaneo( $o_SR_MovimientoDetalleBN->getInicioEscaneo() );
        }
        if ( !is_null( $o_SR_MovimientoDetalleBN->getFinEscaneo() ) )
        {
            $this->setFinEscaneo( $o_SR_MovimientoDetalleBN->getFinEscaneo() );
        }
        if ( !is_null( $o_SR_MovimientoDetalleBN->getPorSerie() ) )
        {
            $this->setPorSerie( $o_SR_MovimientoDetalleBN->getPorSerie() );
        }
        if ( !is_null( $o_SR_MovimientoDetalleBN->getUsuarioRegistro() ) )
        {
            $this->setUsuarioRegistro( $o_SR_MovimientoDetalleBN->getUsuarioRegistro() );
        }
        if ( !is_null( $o_SR_MovimientoDetalleBN->getFechaRegistro() ) )
        {
            $this->setFechaRegistro( $o_SR_MovimientoDetalleBN->getFechaRegistro() );
        }
        if ( !is_null( $o_SR_MovimientoDetalleBN->getUsuarioActualizacion() ) )
        {
            $this->setUsuarioActualizacion( $o_SR_MovimientoDetalleBN->getUsuarioActualizacion() );
        }
        if ( !is_null( $o_SR_MovimientoDetalleBN->getFechaActualizacion() ) )
        {
            $this->setFechaActualizacion( $o_SR_MovimientoDetalleBN->getFechaActualizacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_SR_MovimientoDetalleFN = new SR_MovimientoDetalleFN();
        $o_SR_MovimientoDetalleBN = $o_SR_MovimientoDetalleFN->selectByPk( $this->getMovimientoDetalleId() );
        if ( is_null( $o_SR_MovimientoDetalleBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO SR_MovimientoDetalle ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getMovimientoDetalleId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MovimientoDetalleId";
                $s_SQLQuery2 .= $s_Separator."".$this->getMovimientoDetalleId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMovimientoId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MovimientoId";
                $s_SQLQuery2 .= $s_Separator."".$this->getMovimientoId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getProductoId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ProductoId";
                $s_SQLQuery2 .= $s_Separator."'".$this->getProductoId()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdLote() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdLote";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdLote()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidad() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Cantidad";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadEscaneada() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantidadEscaneada";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidadEscaneada()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getInicioEscaneo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."InicioEscaneo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getInicioEscaneo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFinEscaneo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FinEscaneo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFinEscaneo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPorSerie() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PorSerie";
                $s_SQLQuery2 .= $s_Separator."'".$this->getPorSerie()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioRegistro() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioRegistro";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaRegistro() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaRegistro";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioActualizacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioActualizacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioActualizacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaActualizacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaActualizacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaActualizacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE SR_MovimientoDetalle SET ";
            $s_Separator = "";
            if ( !is_null( $this->getMovimientoId() ) )
            {
                $s_SQLQuery .= $s_Separator."MovimientoId = ".$this->getMovimientoId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getProductoId() ) )
            {
                $s_SQLQuery .= $s_Separator."ProductoId = '".$this->getProductoId()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdLote() ) )
            {
                $s_SQLQuery .= $s_Separator."IdLote = '".$this->getIdLote()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidad() ) )
            {
                $s_SQLQuery .= $s_Separator."Cantidad = ".$this->getCantidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadEscaneada() ) )
            {
                $s_SQLQuery .= $s_Separator."CantidadEscaneada = ".$this->getCantidadEscaneada()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getInicioEscaneo() ) )
            {
                $s_SQLQuery .= $s_Separator."InicioEscaneo = '".$this->getInicioEscaneo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFinEscaneo() ) )
            {
                $s_SQLQuery .= $s_Separator."FinEscaneo = '".$this->getFinEscaneo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPorSerie() ) )
            {
                $s_SQLQuery .= $s_Separator."PorSerie = '".$this->getPorSerie()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioRegistro() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioRegistro = '".$this->getUsuarioRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaRegistro() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaRegistro = '".$this->getFechaRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioActualizacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioActualizacion = '".$this->getUsuarioActualizacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaActualizacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaActualizacion = '".$this->getFechaActualizacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  MovimientoDetalleId = ".$this->getMovimientoDetalleId().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM SR_MovimientoDetalle WHERE  MovimientoDetalleId = ".$this->getMovimientoDetalleId().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>